import java.util.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import fr.inria.cd.CD;
import fr.inria.cd.Order;

/** The CD shop servlet.
 * @author Philippe Poulard
 */
public class CdShopServlet extends HttpServlet {

    // the path used to store order files
    private static final String ORDER_STORE_PATH = "/WEB-INF/orders/";

    /** Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    public void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
        HttpSession session=req.getSession(false);
        String nextUrl = "/index.jsp";
        if (session != null) {
            Vector buyList = (Vector) session.getAttribute( "shopping.cdCart" );
            if ( buyList == null ) {
                buyList = new Vector();
            }
            String action = req.getParameter( "action" );
            if ( "CHECKOUT".equals( action ) ) {
                // display the form for retrieving client infos
                nextUrl = "/order.jsp";
            } else if ( "CHECKOUTNOW".equals( action ) ) {



// order stuff here



                nextUrl = "/thanks.jsp";
            } else {
                if ( "DELETE".equals( action ) ) {
                    String del = req.getParameter( "delIndex" );
                    int d = Integer.parseInt( del );
                    buyList.removeElementAt( d );
                } else if ( "ADD".equals( action ) ) {
                    CD newCd = getCD( req );
                    int index = buyList.indexOf( newCd );
                    if ( index!=-1) {
                        CD cd = (CD) buyList.elementAt( index );
                        cd.setQuantity( cd.getQuantity()+newCd.getQuantity() );
                    } else {
                        buyList.addElement( newCd );
                    }
                }
                session.putValue( "shopping.cdCart", buyList );
            }
        }
        ServletContext ctxt = getServletContext();
        RequestDispatcher rd = ctxt.getRequestDispatcher( nextUrl );
        rd.forward( req, res );
    }

    /** Return a CD selected with this request.
     * @param req The request that contains the CD informations.
     * @return The CD object.
     */
    private CD getCD(HttpServletRequest req) {
        String theCd = req.getParameter( "CD" );
        String qty = req.getParameter( "qty" );
        StringTokenizer t = new StringTokenizer( theCd, "|" );
        CD cd = new CD();
        cd.setArtist( t.nextToken() );
        cd.setAlbum( t.nextToken() );
        cd.setPrice( Float.parseFloat( t.nextToken() ) );
        cd.setQuantity( Integer.parseInt( qty ) );
        return cd;
    }

}