package fr.inria.cd;

/** A CD.
 * @author Philippe Poulard
 */
public class CD {
    // the name of the album
    private String album="";
    // the artist
    private String artist="";
    // the price
    private float price=0;
    // the quantity
    private int quantity=0;

    /** Create a new instance of CD.
     */
    public CD() {}

    /** Set the name of this album.
     * @param album The name of the album.
     */
    public void setAlbum( String album ) {
        this.album = album;
    }

    /** Get the name of this album.
     * @return The name of this album.
     */
    public String getAlbum() {
        return this.album;
    }

    /** Set the artist for this album.
     * @param artist The name of the artist.
     */
    public void setArtist( String artist ) {
        this.artist = artist;
    }

    /** Get the artist for this album.
     * @return The name of the artist.
     */
    public String getArtist() {
        return this.artist;
    }

    /** Set the price of this album.
     * @param price The price.
     */
    public void setPrice( float price ) {
        this.price = price;
    }

    /** Get the price of this album.
     * @return The price.
     */
    public float getPrice() {
        return this.price;
    }

    /** Set the quantity to order.
     * @param quantity The quantity to order.
     */
    public void setQuantity( int quantity ) {
        this.quantity = quantity;
    }

    /** Get the quantity to order.
     * @return The quantity to order.
     */
    public int getQuantity() {
        return this.quantity;
    }

    /** Indicates whether some other object is "equal to" this one.
     * 2 CD are equals if the name of the albums are equals and the artists are equals.
     * param o The reference object with which to compare.
     */
    public boolean equals(Object o) {
        if (o instanceof CD) {
            CD cd = (CD) o;
            return this.album.equals(cd.album) && this.artist.equals(cd.artist);
        }
        return false;
    }

    /** Returns a hash code value for the object.
     * @return A hash code value for the object.
     */
    public int hashCode() {
        return this.album.hashCode() ^ this.artist.hashCode();
    }

}