package fr.inria.cd;

import java.util.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;
import javax.xml.parsers.*;
import javax.xml.transform.*;
import javax.xml.transform.sax.*;
import javax.xml.transform.stream.*;

/** An order.
 * @author Philippe Poulard
 */
public class Order {

    // the namespace URI of orders
    public static final String
        ORDER_NS = "urn:inria.fr-order";

    // the order number
    private int orderNumber = 0;
    // the items
    private Vector items = new Vector();
    // the path to the directory where to store this order
    private String directory = "";
    // the customer name
    private String customerName = "";
    // the customer address
    private String customerAddress = "";
    // the customer credit card number
    private String customerCreditCard = "";

    /** Create a new instance of order.
     */
    public Order() {}

    /** Set the name of the customer of this order.
     * @param customerName The name of the customer.
     */
    public void setCustomerName( String customerName ) {
        this.customerName = customerName;
    }

    /** Get the name of the customer of this order.
     * @return The name of the customer.
     */
    public String getCustomerName() {
        return this.customerName;
    }

    /** Set the address of the customer of this order.
     * @param customerAddress The address of the customer.
     */
    public void setCustomerAddress( String customerAddress ) {
        this.customerAddress = customerAddress ;
    }

    /** Get the address of the customer of this order.
     * @return The address of the customer.
     */
    public String getCustomerAddress() {
        return this.customerAddress;
    }

    /** Set the credit card number of the customer of this order.
     * @param customerCreditCard The credit card number of the customer.
     */
    public void setCustomerCreditCard( String customerCreditCard ) {
        this.customerCreditCard = customerCreditCard;
    }

    /** Get the credit card number of the customer of this order.
     * @return The credit card number of the customer.
     */
    public String getCustomerCreditCard() {
        return this.customerCreditCard;
    }

    /** Set the directory where to store this order.
     * @param directory The directory where to store this order.
     */
    public void setDirectory( String directory ) {
        this.directory = directory;
    }

    /** Get the directory where to store this order.
     * @return The directory where to store this order.
     */
    public String getDirectory() {
        return this.directory;
    }

    /** Set the order number.
     * @param orderNumber The order number.
     */
    public void setOrderNumber( int orderNumber ) {
        this.orderNumber = orderNumber;
    }

    /** Get the order number.
     * @return The order number.
     */
    public int getOrderNumber() {
        return this.orderNumber;
    }

    /** Set the items to order.
     * @param item The items to order.
     */
    public void setItems( Vector items ) {
        this.items = items;
    }

    /** Get the items to order.
     * @return The items to order.
     */
    public Vector getItems() {
        return this.items;
    }

    /** Serialize this order to an XML file.
     */
    public void serializeToXMLFile()  throws TransformerConfigurationException, SAXException {



// retrieve the SAX serializer and use ContentHandler methods



    }

    /** Return a SAX serializer
     * @param outputFileName The file name to write to.
     * @return The identity transformer that serialize SAX events.
     */
    private TransformerHandler getSerializer(String outputFileName) throws TransformerConfigurationException {
        TransformerFactory factory = TransformerFactory.newInstance();
        TransformerHandler transformerHandler = ((SAXTransformerFactory) factory).newTransformerHandler();
        Result result = new StreamResult( outputFileName );
        transformerHandler.setResult( result );
        return transformerHandler;
    }

}